#ifndef CGPS_UTILS_H
#define CGPS_UTILS_H

#include "chaversine.h"

#include <QObject>

#include <QMessageBox>

#include <QString>
#include <QStringList>



class cGPS_utils : public QObject
{
    Q_OBJECT
public:
    explicit cGPS_utils(QObject *parent = 0);

signals:

    void gps_ready(QString cgi_message);

public slots:

    void recieve_GPS(QString message);

public:

    cHaversine *cHav;

    void mark_start_GPS();
    void mark_stop_GPS();

    double getGPS_Dist_m(double lat1_degs, double lon1_degs, double lat2_degs, double lon2_degs);

    void calc_gps_dist();

    bool gps_mark_status = false;

    QString sLat;
    QString sLon;

    QString sStartLat;
    QString sStartLon;
    QString sUTC = "0.0";
    QString sVel = "0.0";
    QString sDist = "0.0";

    QString sVel_knots;
    QString sHeading_degs;
    QString sDate_gps;

    QString sStartUTC = "0.0";
    QString sStopUTC = "0.0";

    double lat_degs;
    double lon_degs;

    double start_lat_degs;
    double start_lon_degs;

    double last_lat_degs;
    double last_lon_degs;

    double area_harvested;
    QString sArea_harvested = "0.0";


//these vals in degrees & meters
    double lat1, lon1, lat2, lon2, dist, total_dist;

    //engr parm
    double row_width_in = 40.0;
    double row_width_ft = 40.0 / 12.0;
    double area_acre_sqft = 43560.0;
    double num_rows = 6;  //size of machine; 6 row header ect

    QString sRow_width_in = "40.0";
    QString sNum_rows = "6";


    void test_gps();

private:

    QString sGPS_msg1 = "\$GPRMC,1235195,A,4807.0385,N,01131.000,E,022.4,084.4,230394,003.1,W*6A";
    QString sGPS_msg2 = "\$GPRMC,1235194,A,4807.0384,N,01131.100,E,022.4,084.4,230394,003.1,W*6A";

    double degs2rads(double x_degs);

    double gps_lat_conv2degs(QString sLat_gps);
    double gps_lon_conv2degs(QString sLon_gps);
    void extract_gps_msg(QString gps_msg);

    double get_radius_earth_m(double lat_degs, double altitude_m);

    double gps_distance(double lat1_degs, double lon1_degs, double lat2_degs, double lon2_degs);


    double e = 2.718281828;



};

#endif // CGPS_UTILS_H
