#include "chaversine.h"

#include "cgps_utils.h"


#include <QtMath>

cHaversine::cHaversine(QObject *parent) :
    QObject(parent)
{
}


double cHaversine::gps_distance(double lat1_degs, double lon1_degs, double lat2_degs, double lon2_degs)
{
    // double lat1=45.54243333333333,lat2=45.53722222,long1=-122.96045277777778,long2=-122.9630556;
    // Below is the main code

double PI = 4.0*atan(1.0);

//main code inside the class
double dlat1=lat1_degs*(PI/180);
double dlong1=lon1_degs*(PI/180);

double dlat2=lat2_degs*(PI/180);
double dlong2=lon2_degs*(PI/180);

double dLong=dlong1-dlong2;
double dLat=dlat1-dlat2;

double aHarv= pow(sin(dLat/2.0),2.0)+cos(dlat1)*cos(dlat2)*pow(sin(dLong/2),2);
double cHarv=2*atan2(sqrt(aHarv),sqrt(1.0-aHarv));

double distance=earth*cHarv;


distance = distance * 100 / 2.54 /12.0;


return distance;  //distance in ft


}

//dist calc in gps-utils is wrong; use the one in this class instead
void cHaversine::test_distance()
{
    //test our func in cgps_utils.h
    cGPS_utils cgps;

    double lat1_degs = 33.68015556, lat2_degs = 33.68013889, lon1_degs = -101.6899139, lon2_degs = -101.6915167;

    //should be 492ft E-W  (lat-lon from Google Earth and dist is about right considering property dims)
    double dist1 = gps_distance(lat1_degs, lon1_degs, lat2_degs, lon2_degs);

    double dist1b = cgps.getGPS_Dist_m(lat1_degs,lon1_degs,lat2_degs,lon2_degs);

    lat1_degs = 33.68015833; lat2_degs = 33.67928889; lon1_degs = -101.6913167; lon2_degs = -101.691325;

    //should be 316ft N-S  (lat-lon from Google Earth and dist is about right considering property dims)
    double dist2 = gps_distance(lat1_degs, lon1_degs, lat2_degs, lon2_degs);


    double dist2b = cgps.getGPS_Dist_m(lat1_degs,lon1_degs,lat2_degs,lon2_degs);

    int x = 3;
}


//test 2
void cHaversine::test2_distance()
{
    //test our func in cgps_utils.h
    cGPS_utils cgps;

    double lat1_degs = 33.0 + 41.609814/60.0;
    double lon1_degs = 101.0 + 49.165994/60.0;

    double lat2_degs = 33.0 + 41.562193/60.0;
    double lon2_degs = 101.0 + 49.166055/60.0;


    //double lat1_degs = 33.68015556, lat2_degs = 33.68013889, lon1_degs = -101.6899139, lon2_degs = -101.6915167;

    //should be 492ft E-W  (lat-lon from Google Earth and dist is about right considering property dims)
    double dist1 = gps_distance(lat1_degs, lon1_degs, lat2_degs, lon2_degs);

    double dist1b = cgps.getGPS_Dist_m(lat1_degs,lon1_degs,lat2_degs,lon2_degs);

//    lat1_degs = 33.68015833; lat2_degs = 33.67928889; lon1_degs = -101.6913167; lon2_degs = -101.691325;

    //should be 316ft N-S  (lat-lon from Google Earth and dist is about right considering property dims)
    double dist2 = gps_distance(lat1_degs, lon1_degs, lat2_degs, lon2_degs);


    double dist2b = cgps.getGPS_Dist_m(lat1_degs,lon1_degs,lat2_degs,lon2_degs);

    int x = 3;
}


